/* scivi - visualization plugin for XMMS
 * Copyright (C) 2003 Vitaly V. Bursov <vitalyb@mail333.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef FPSCTL_H
#define FPSCTL_H

#include "scivi.h"
#include "common.h"
#include "dynam.h"
#include "gui.h"

typedef void *FPSControl;

typedef struct {
	const char *descr;
	int uuid;
	FPSControl (*fps_control_init)(Scivi *scivi, DynamicsData *dyn_data, Gui gui);
	void (*fps_control_finit)(Scivi *scivi, FPSControl fc);
	int (*fps_control_frame_start)(Scivi *scivi, FPSControl fc, DynamicsData *dyn_data, Gui gui);
	void (*fps_control_frame_end)(Scivi *scivi, FPSControl fc, DynamicsData *dyn_data, Gui gui);
	int (*fps_control_post_decay_frames_cnt)(Scivi *scivi, FPSControl fc);
	void (*fps_control_decay_point)(Scivi *scivi, FPSControl fc);
} FPSController;

FPSController *scivi_get_fps_ctl(int idx);
FPSController *scivi_get_fps_ctl_by_uid(int uid);
int scivi_get_fps_ctl_count();

#endif /* FPSCTL_H */
