/* scivi - visualization plugin for XMMS
 * Copyright (C) 2003 Vitaly V. Bursov <vitalyb@mail333.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef GUI_H
#define GUI_H

/*#ifdef HAVE_LIBSDL_TTF
#include <SDL_ttf.h>
#endif*/

/*#ifdef HAVE_LIBSDL_TTF*/
#if 0

#include "presets.h"

typedef struct {
	int initialized;
	
	int width, height;

	char *song_title;

	float fps;
	int fps_changed;
	unsigned int list_id_fps;

	int max_fonts;
	TTF_Font **fonts;

	PresetInfo *preset_info;
	int preset_info_changed;

	unsigned int list_ids;

} Gui_t, *Gui;

/******************************/

Gui gui_setup(char *fontfilename);
void gui_finit(Gui gui);
void gui_draw(Gui gui);

/*
 * return: 0 - event is not processed
 *         1 - event is processed and should not be processed futrher
 */

int gui_process_event(Gui gui, SDL_Event *event);

void gui_set_fps(Gui gui, float fps);
void gui_set_presetinfo(Gui gui, PresetInfo *preset_info);
void gui_set_dimensions(Gui gui, int width, int height);

#else /* HAVE_LIBSDL_TTF */

#define Gui void*
#define gui_setup(a) 0
#define gui_finit(a)
#define gui_draw(a)

#define gui_process_event(a,b) 0

#define gui_set_fps(a,b)
#define gui_set_presetinfo(a,b)
#define gui_set_dimensions(a,b,c)

#endif /* HAVE_LIBSDL_TTF */

#endif /* ! GUI_H */

