/* scivi - visualization plugin for XMMS
 * Copyright (C) 2003 Vitaly V. Bursov <vitalyb@mail333.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef PRESETS_H
#define PRESETS_H

#define PRESET_NAME_MAX_LEN 32
#define PRESET_AUTHOR_MAX_LEN 64

typedef struct {
	char *name;
	char *author;
	char *uuid;
	int rating;

	int init_lineoffs;
	int pframe_lineoffs;
	int ppixel_lineoffs;
	int postframe_lineoffs;

	int init_clen;
	int pframe_clen;
	int ppixel_clen;
	int postframe_clen;
	
	char *init;
	char *pframe;
	char *ppixel;
	char *postframe;
} PresetInfo;


PresetInfo *scivi_preset_load_from_file(char *fn);
int scivi_preset_load_from_dir(char *dir, PresetInfo **pis);
int scivi_preset_load_from_dirs(char **dirs, PresetInfo **pis);
void scivi_presets_free(PresetInfo *pis, int cnt);
void scivi_preset_free(PresetInfo *pi);

#endif /* !  PRESETS_H */
